//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#include "DataObjects.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OleDnD"
#pragma link "MSGSnatchers"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DFItem_CF_HDROP_Drop(TObject *aSender,
	  TDragContext &aContext)
{
	PageControl1->ActivePage = TabSheetUnsupported;
	MemoCFHDrop->Clear();
	TDataObjectReader* reader = new TDataObjectReader(aContext.DataObject);
	try{
		reader->GetAsFileList(MemoCFHDrop->Lines);
		PageControl1->ActivePage = TabSheetCFHDrop;
	} __finally{
		delete reader;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DFItem_CF_TEXT_Drop(TObject *aSender,
	  TDragContext &aContext)
{
	PageControl1->ActivePage = TabSheetUnsupported;
	MemoCFHDrop->Clear();
	TDataObjectReader* reader = new TDataObjectReader(aContext.DataObject);
	try{
		MemoCFText->Text = reader->AsText;
		PageControl1->ActivePage = TabSheetCFText;
	} __finally{
		delete reader;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DFItem_CF_BITMAP_Drop(TObject *aSender,
	  TDragContext &aContext)
{
	PageControl1->ActivePage = TabSheetUnsupported;
	MemoCFHDrop->Clear();
	TDataObjectReader* reader = new TDataObjectReader(aContext.DataObject);
	Graphics::TBitmap* bitmap = new Graphics::TBitmap();
	try{
		if(reader->HasFormat(CF_PALETTE)){
			bitmap->Palette = reader->GetAsHandle(CF_PALETTE, TYMED_HGLOBAL);
		}
		reader->GetAsBitmap(bitmap);
		ImageCFBitmap->Picture->Bitmap = bitmap;
		PageControl1->ActivePage = TabSheetCFBitmap;
	} __finally{
		delete bitmap;
		delete reader;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileDropTarget1FileDragEnter(TObject *aSender,
	  TDragContext &aContext)
{
	MemoFileDrag->Clear();
	MemoFileDrag->Lines->Add("DragEnter");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileDropTarget1FileDragOver(TObject *aSender,
	  TDragContext &aContext)
{
	MemoFileDrag->Lines->Add("DragOver");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileDropTarget1FileDragLeave(TObject *aSender,
	  HRESULT &aResult)
{
	MemoFileDrag->Lines->Add("DragLeave");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileDropTarget1FileDrop(TObject *aSender,
	  TDragContext &aContext)
{
	MemoFileDrag->Lines->Add("Drop");
	MemoFileDrag->Lines->Add(FileDropTarget1->DroppedFiles->Text);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddFormatEtc(const TFormatEtc& aFormat)
{
	ListBoxFormats->Items->Add(GetCFName(aFormat.cfFormat));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OleDropTarget1DragEnter(TObject *aSender,
	  TDragContext &aContext)
{
	ListBoxFormats->Clear();
	TDataObjectReader* reader = new TDataObjectReader(aContext.DataObject);
	try{
		reader->GetFormats(AddFormatEtc);
	} __finally{
		delete reader;
	}
}
//---------------------------------------------------------------------------

